<template>
    <div :style="style" v-text="letters"></div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
@Component
export default class UserIcon extends Vue {
    @Prop({ default: '' }) readonly src!: string;
    @Prop({ default: '' }) readonly name!: string;
    @Prop({ default: '50px' }) readonly size!: string;

    get style() {
        let rules = `border-radio:50%;`;
        rules += `height: ${this.size}; width: ${this.size};`;

        if (this.src) {
            rules += `background-image: url('${this.src}');`;
            rules += `background-size: contain;`;
            rules += `background-repeat: no-repeat;`;
        } else {
            rules += `background-color: #dae0e2;`;
            rules += `line-height: ${this.size}`;
        }
        return rules;
    }

    get letters() {
        return this.name && !this.src ? this.name.charAt(0).toUpperCase() : '';
    }
}
</script>

<style scoped>
div {
    border-radius: 50%;
    display: flex;
    justify-content: center;
    font-size: 2em;
    font-weight: bolder;
}
</style>
